//
// IC-9100 command monitor
//
#include <windows.h>
#include <conio.h>
#include <stdio.h>

int ReadCmd();
void RecvCmd();
void MsgCmd();

int port;
char portget[16];
DWORD nn;
unsigned char cbuf[1];
unsigned char ibuf[255];
int ip;
HANDLE h;
DCB dcb;

char	cmdrxbgn[9]={0xFE,0xFE,0x7C,0xE0,0x20,0x00,0x00,0x01,0xFD};
char	cmdmsgbgn[9]={0xFE,0xFE,0x7C,0xE0,0x20,0x01,0x00,0x01,0xFD};

void main()
{
	fprintf(stderr,"IC-9100 command monitor version 0.99\n\n");
com:	fprintf(stderr,"bnlԍ͂Ă :");
	gets(portget);
	if(portget[0]=='\0'){
		return;
	}else{
		sscanf(portget,"%d",&port);
		sprintf(portget,"\\\\.\\COM%d",port);
	}

	h = CreateFile( portget,
			GENERIC_READ | GENERIC_WRITE,
			0,
			0,
			OPEN_EXISTING,
			0, 0);
	if ( h == INVALID_HANDLE_VALUE ) {
		printf("I[vEG[\n");
		goto com;
	}

	GetCommState( h, &dcb );
	dcb.ByteSize = 8;
	dcb.BaudRate = 19200;	//{[Cg
	dcb.fParity = 0;
	dcb.fOutxCtsFlow = 0;
	if ( ! SetCommState( h, &dcb)) {
		printf("cbãG[\n");
		return;
	}

	COMMTIMEOUTS cto;
	cto.ReadIntervalTimeout		= 10;
	cto.ReadTotalTimeoutMultiplier	= 0;
	cto.ReadTotalTimeoutConstant	= 10;
	cto.WriteTotalTimeoutMultiplier	= 0;
	cto.WriteTotalTimeoutConstant	= 0;
	SetCommTimeouts( h, &cto );

	char c;
	char ack;
	ip = 0;

	ack = 2;
	while(1){
		if( kbhit() ){
			c = getch();
			if( c == 3 ) break;
			if( c == 0x1b ) break;
		}
		if(ack==2){ // rx call output
			WriteFile( h, cmdrxbgn, 9, &nn, 0);
			ack = 3;
		}
		if(ack==4){ // msg output
			WriteFile( h, cmdmsgbgn, 9, &nn, 0);
			ack = 5;
		}
		if(ack==6){ // start recieving
			printf("IC-9100 recieving ready\n");
			ack = 7;
		}
		if(ack==7){ // idoling...
			//
		}
		if(ReadCmd()){
			RecvCmd();
			MsgCmd();
			if(ack==3){ ack = 4; }
			if(ack==5){ ack = 6; }
			ip = 0;
		}
	}
	CloseHandle( h );

	fprintf(stderr,"Hit anykey\n");
	getch();
	return;
}

//////////////////////////////////////////////////////
int ibhead;

int ReadCmd()
{
	ReadFile( h, cbuf, 1, &nn, 0);
	if( nn == 1 ) {
		ibuf[ip] = cbuf[0];
		if(cbuf[0]==0xfe) ibhead=ip;
		if(ip<253) ip++;
		if(cbuf[0]==0xfd) {
			// ignore echoback
			if(ibuf[ibhead+1]!=0x7C) return 1;
			if(ibuf[ibhead+2]!=0xE0) return 1;
			ip=0;
			return 0;
		}
	}
	return 0;
}

// display recieved message(20char)
void MsgCmd()
{
	int i;

	if(ibuf[0]!=0xfe) goto exit;
	if(ibuf[1]!=0xfe) goto exit;
	if((ibuf[4]!=0x20)||(ibuf[5]!=0x01)||(ibuf[6]!=0x01)) goto exit;
	printf("Msg:");
	for(i=7;i<27;i++) printf("%c",((ibuf[i]>=0x20)&&(ibuf[i]<=0xdf))?ibuf[i]:'.');
	printf("\n");
exit:
	return;
}

// display recieved callsign and repeaters
void RecvCmd()
{
	int i;
	if(ibuf[0]!=0xfe) goto exit;
	if(ibuf[1]!=0xfe) goto exit;
	if(ibuf[4]!=0x20) goto exit;
	if(ibuf[5]!=0x00) goto exit;
	if(ibuf[6]!=0x01) goto exit;
	for(i=9;i<17;i++) printf("%c",ibuf[i]); // caller
	printf("  /");
	for(i=17;i<21;i++) printf("%c",ibuf[i]);
	printf("   ");
	for(i=21;i<29;i++) printf("%c",ibuf[i]); // ur
	printf("   ");
	for(i=29;i<37;i++) printf("%c",ibuf[i]); // rpt1
	printf("   ");
	for(i=37;i<45;i++) printf("%c",ibuf[i]); // rpt2
	if(ibuf[8]==1)      printf("  RPT?");
	else if(ibuf[8]==2) printf("  UR?");
	printf("\n");
exit:
	return;
}
